<?php
/*
 * PiAnoS (Picture Annotation System), A fingerprint examiner training tool
 * Copyright (C) 2011-2013 University of Lausanne, Switzerland
 * https://ips-labs.unil.ch/pianos
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see http://www.gnu.org/licenses/.
 */

// BEGIN-BUILDSCRIPT-SECTION-1
define( '_DEBUG', false );

/*
 * This file is actually completely replaced by the build script [1].
 * In development builds, it will read the local-database.udb file and
 * infer the version of PiAnoS we want to load (from the
 * 'import pianos4-XXX.udb' clause).
 *
 * In production builds, PiAnoS 4 Teaching Edition will always be loaded.
 * This may (will) change in the future when Lab Edition is released, but
 * for the moment we assume 'PiAnoS 4' builds are really 'PiAnoS 4 TE' builds.
 *
 * [1] See tools/build.py
 */

// $pianos4_is_lab_edition = NULL;
function isLabEdition()
{
    static $pianos4_is_lab_edition = NULL;
    if( $pianos4_is_lab_edition === NULL )
    {
        $ls = file_get_contents( 'database/local-database.udb' );
        $found = strpos( $ls, 'import pianos4-le.udb' );
        $pianos4_is_lab_edition = $found !== false;
    }
    return $pianos4_is_lab_edition;
}

if( isLabEdition() )
{
    // Lab Edition
    require_once ( "backend/Pianos4_LE.php" );
    $app = new Pianos4_LE();
} else
{
    // Teaching Edition
    require_once ( "backend/Pianos4_TE.php" );
    $app = new Pianos4_TE();
}
$app->run();

// END-BUILDSCRIPT-SECTION-1
